
Opt('GUICloseOnESC', 0)
Opt('GUIOnEventMode', 1)
Opt('MustDeclareVars', 1)
Opt('MouseCoordMode', 2)

#include <GDIPlus.au3>


Global $hGUI, $hBuf, $hGFX, $hBMP, $hMatrix, $hImg

_GDIPlus_Startup()

$hGUI = GUICreate('Test', 400, 400)

$hGFX = _GDIPlus_GraphicsCreateFromHWND($hGUI)
$hBMP = _GDIPlus_BitmapCreateFromGraphics(400, 400, $hGFX)
$hBuf = _GDIPlus_ImageGetGraphicsContext($hBMP)

_GDIPlus_GraphicsSetSmoothingMode($hBuf, 2)
_GDIPlus_GraphicsSetSmoothingMode($hGFX, 2)

$hMatrix = _GDIPlus_MatrixCreate()

$hImg = _GDIPlus_ImageLoadFromFile('unnamed.png')


GUISetOnEvent(-3, '_Exit', $hGUI)
GUIRegisterMsg(0xF, 'WM_PAINT')
OnAutoItExitRegister('_Freigeben')
GUISetState(@SW_SHOW, $hGUI)


While Sleep(100)
	_Rotieren()
	WM_PAINT()
WEnd

Func _Rotieren()

	Local Static $iDeg = 0
	$iDeg += 1 - ($iDeg > 359)*359

	_GDIPlus_GraphicsClear($hBuf, 0xFF000000)

	_GDIPlus_MatrixRotate($hMatrix, 1)

	_GDIPlus_GraphicsSetTransform($hBuf, $hMatrix)
	_GDIPlus_GraphicsDrawImage($hBuf, $hImg, 0, 0)

EndFunc

Func _Exit()
	Exit
EndFunc

Func WM_PAINT()
	_GDIPlus_GraphicsDrawImage($hGFX, $hBMP, 0, 0)
EndFunc

Func _Freigeben()

	_GDIPlus_MatrixDispose($hMatrix)

	_GDIPlus_GraphicsDispose($hGFX)
	_GDIPlus_GraphicsDispose($hGFX)
	_GDIPlus_BitmapDispose($hBMP)

	_GDIPlus_Shutdown()
EndFunc